#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct drvo {
	int treca_cifra;
	int broj;
	struct drvo *desni,*levi;
} DRVO;

DRVO *Dodaj(DRVO *p,DRVO *temp)
{
	
		if (p==NULL) {
			p=temp;
			p->levi=NULL;
			p->desni=NULL;
			
		}
	else {
		
		if (p->treca_cifra<temp->treca_cifra) {
			
			p->desni=Dodaj(p->desni,temp);
		} 
		else {
			
			p->levi=Dodaj(p->levi,temp);
		}
	}
 return (p);
}

DRVO *Kreiraj(DRVO *p)
{
	int n,i;
	DRVO *temp;
	
	scanf("%d",&n);
	for(i=0;i<n;i++) {
			temp=malloc(sizeof(DRVO));
			scanf("%d",&temp->broj);
			if ((temp->broj)/100==0)
			 temp->treca_cifra=0; 
					
			else 
				 
				temp->treca_cifra=((temp->broj)/100)%10;
   
	p=Dodaj(p,temp); 
 }
	return(p);
}

void Ispis(DRVO *p)
{
	if (p != NULL) {
		Ispis(p->desni);
		printf("%d %d",p->broj,p->treca_cifra);
		Ispis(p->levi);
	}

}

void Brojac(DRVO *p,int x,int *suma)
{
	if (p != NULL) {
	Brojac(p->desni,x,suma);
	Brojac(p->levi,x,suma);
	
	if (x<p->treca_cifra && p->treca_cifra>2 && p->treca_cifra<8) 
	{
			(*suma)++;
	}
 }
}

main()
{
	DRVO *p=NULL;
	int x;
	int suma;
	
	Kreiraj(p);
	Ispis(p);
	printf("Unesite x: \n");
	scanf("%d",&x);
	printf("Tih brojeva ima: ");
	Brojac(p,x,&suma);
	printf("%d\n",suma);
}
