#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct Stablo {
	int broj;
	int treca_cifra;
	struct Stablo *levi, *desni;
}cvor;

#define novi(x) x = (cvor *)malloc(sizeof(cvor));

void dodaj(cvor **p, int br, int cifra) {
	cvor *pom1, *pom2,*temp;
	novi(temp);
	if(!temp) perror("Greska pri alokaciji memorije\n");
	temp->broj = br;
	temp->treca_cifra = cifra;
	if(!(*p)) {
		temp->levi = temp->desni = NULL;
		*p = temp;
	}	
	else {
		pom1 = *p;
		while(pom1 != NULL) {
			pom2 = pom1;
			if(pom1->treca_cifra > cifra) pom1 = pom1->levi;
			else pom1 = pom1->desni;
		}
		if(pom2->treca_cifra > cifra) pom2->levi = temp;
		else pom2->desni = temp;
	}
}

int Treca(int broj) {
	int br = 0, t=0, n = 2;
	while(n>0) {
		broj/=10;
		n--;
	}
	return broj%10;
}

int koliko(cvor *p, int k) {
	int s = 0;
	if(p) {
		s = s+koliko(p->levi,k);
		if((p->broj > k) && ((Treca(p->broj)==3) || (Treca(p->broj)==4) || (Treca(p->broj)==5) || (Treca(p->broj)==6) || (Treca(p->broj)==7)))
		s++;
		s=s+koliko(p->desni,k);
	}
	return s;
}

void Ispis(cvor *p) {
	if(p) {
		Ispis(p->desni);
		printf("Broj: %d\t Cifra:%d \n",p->broj,p->treca_cifra);
		Ispis(p->levi);
	}
	
}

main(){
	cvor *p = NULL;
	int n,i,broj,cifra,x;
	printf("Unesite broj cvorova u stablu: \n");
	scanf("%d",&n);
	for(i = 0; i < n; i++) {
		scanf("%d",&broj);
		dodaj(&p,broj,Treca(broj));
	}
	Ispis(p);
	printf("Unesite x:\n");
	scanf("%d",&x);
	printf("Ima ukupno %d broja/brojeva koji su veci od X i kojima je treca cifra izmedju 2 i 8\n",koliko(p,x));
}
