#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct node
{
	char* naziv;
	float udaljenost;
	struct node* next;
} node;

#define new(x) x = (node*)malloc(sizeof(node))

node* form();
void add(node** p, char* s, float k);
void print(node* p);

node* form()
{
	node *p = NULL;
	char s[100];
	float k;
	while(1)
	{
		gets(s);
		scanf("%f",&k);
		getchar();
		add(&p, s, k);
		if(!strcmp(s, "OKRUG"))
			break;
	}
	return p;
}

void add(node** p, char* s, float k)
{

	node *tmp, *pos1, *pos2;
	new(tmp);
	if(!tmp)
	{
		printf("Greskaa\n");
		exit(0);
	}
	tmp->naziv = (char*)malloc(strlen(s) + 1);
	strcpy(tmp->naziv, s);
	tmp->udaljenost = k;

	if(!(*p))
	{
		tmp->next = tmp;
		*p = tmp;	
	}
	else
	{
		pos1 = *p;
		while(pos1->next != (*p))
			pos1 = pos1->next;
		tmp->next = pos1->next;
		pos1->next = tmp;
	}

}

void print(node* p)
{
	node* pos;
	pos = p;
	do
	{	
		printf("%s\t%.2f\n", pos->naziv, pos->udaljenost);
		pos = pos->next;
	}while(pos != p);
}

void change(node **p)
{
	node *pos1, *pos2, *res;
	res = *p;	
	pos1 = NULL;
	pos2 = NULL;
	float n = 0;		
	do
	{
		n += res->udaljenost;
		if(n > 100)		
		{
			pos1->udaljenost = n - res->udaljenost;
			if(pos2 == NULL)	
			{
				pos2 = pos1;
				*p = pos1;	
			}
			else
			{
				pos2->next = pos1;
			}	
			n = 0;
		}
		pos1 = res;
		res = res->next;
	}while(res != pos2);

}

int main(void)
{
	node* p;	
	p = form();
	print(p);
	printf("\n");
	change(&p);
	print(p);
}
